// Access to ion assets
Cesium.Ion.defaultAccessToken = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJqdGkiOiJkNjFiNWZkYi1iMDQxLTQxMzUtYjViOC1hOWQ2MDdmMjZiZjYiLCJpZCI6Mjk0MDIsInNjb3BlcyI6WyJhc3IiLCJnYyJdLCJpYXQiOjE1OTIxMjM5MDF9.r5WVYRNMd0JggWOQOvfPI8dvhC31zbuCSj0mxf_nl5k";

// Styles
var buildingStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#fffafa')"
});

var roofStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#ff0033')",
 show: true
});

var windowStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#87ceeb')"
});

var doorStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#d2691e')"
});

var outerfloorStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#708090')"
});

var installationStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#a9a9a9')"
});

var veg_implicit_geomStyle = new Cesium.Cesium3DTileStyle({
 color: "color('#9acd32')"
});

var pvPotentialYield = new Cesium.Cesium3DTileStyle({
 color: {
  conditions: [ [ "${ColorStyleRoof} === '1'", "color('#FFFF99')" ], [ "${ColorStyleRoof} === '2'", "color('#FFFF66')" ], [ "${ColorStyleRoof} === '3'", "color('#FFFF33')" ], [ "${ColorStyleRoof} === '4'", "color('#FFCC33')" ], [ "${ColorStyleRoof} === '5'", "color('#FFA500')" ], [ "${ColorStyleRoof} === '6'", "color('#FF8C00')" ], [ "${ColorStyleRoof} === '7'", "color('#FF6347')" ], [ "${ColorStyleRoof} === '8'", "color('#FF4500')" ], [ "${ColorStyleRoof} === '9'", "color('#B22222')" ], [ "${ColorStyleRoof} === '10'", "color('#8B0000')" ], [ "true", "color('#fffafa')" ] ]
 }
});

// HomeView
var extent = Cesium.Rectangle.fromDegrees(9.072, 48.754, 9.303, 48.819);

Cesium.Camera.DEFAULT_VIEW_RECTANGLE = extent;

Cesium.Camera.DEFAULT_VIEW_FACTOR = 0;

// Viewer with Terrain Model from Ion Account
var viewer = new Cesium.Viewer("cesiumContainer", {
 terrainProvider: new Cesium.CesiumTerrainProvider({
  url: Cesium.IonResource.fromAssetId(1)
 })
});

viewer.scene.globe.depthTestAgainstTerrain = true;

// Loading user tilesets
// LoD1-Stuttgart
var tileset_str = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/str_lod1/str_lod1.json"
}));

tileset_str.style = buildingStyle;

tileset_str.show = false;

// LoD2-Stuttgart
var tileset_str2 = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/str_lod2/str_lod2.json"
}));

tileset_str2.style = buildingStyle;

tileset_str2.show = false;

var tileset_str2_outerfloor = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/str_lod2/outerfloor/str_lod2_outerfloor.json"
}));

tileset_str2_outerfloor.style = outerfloorStyle;

tileset_str2_outerfloor.show = false;

var tileset_str2_roof = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/str_lod2/roof/str_lod2_roof.json"
}));

tileset_str2_roof.show = false;

//Fernsehturm Stuttgart
var tileset_fernseh = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/fernsehturm/fernsehturm.json"
}));

tileset_fernseh.style = buildingStyle;

tileset_fernseh.show = false;

var tileset_fernseh_installation = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/fernsehturm/installation/fernsehturm_installation.json"
}));

tileset_fernseh_installation.style = installationStyle;

tileset_fernseh_installation.show = false;

var tileset_fernseh_outerfloor = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/fernsehturm/outerfloor/fernsehturm_outerfloor.json"
}));

tileset_fernseh_outerfloor.style = outerfloorStyle;

tileset_fernseh_outerfloor.show = false;

var tileset_fernseh_roof = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/fernsehturm/roof/fernsehturm_roof.json"
}));

tileset_fernseh_roof.style = roofStyle;

tileset_fernseh_roof.show = false;

var tileset_fernseh_window = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/fernsehturm/window/fernsehturm_window.json",
 maximumScreenSpaceError: "0"
}));

tileset_fernseh_window.style = windowStyle;

tileset_fernseh_window.show = false;

//Steubenstrasse
var tileset_steub = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/steubenstrasse/steubenstrasse.json"
}));

tileset_steub.style = buildingStyle;

tileset_steub.show = false;

var tileset_steub_roof = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/steubenstrasse/roof/steubenstrasse_roof.json"
}));

tileset_steub_roof.style = roofStyle;

tileset_steub_roof.show = false;

//Justizausbildungszentrum
var tileset_justiz = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/justizausbildungszentrum.json"
}));

tileset_justiz.style = buildingStyle;

tileset_justiz.show = false;

var tileset_justiz_door = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/door/justizausbildungszentrum_door.json"
}));

tileset_justiz_door.style = doorStyle;

tileset_justiz_door.show = false;

var tileset_justiz_installation = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/installation/justizausbildungszentrum_installation.json"
}));

tileset_justiz_installation.style = installationStyle;

tileset_justiz_installation.show = false;

var tileset_justiz_outerfloor = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/outerfloor/justizausbildungszentrum_outerfloor.json"
}));

tileset_justiz_outerfloor.style = outerfloorStyle;

tileset_justiz_outerfloor.show = false;

var tileset_justiz_roof = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/roof/justizausbildungszentrum_roof.json"
}));

tileset_justiz_roof.style = roofStyle;

tileset_justiz_roof.show = false;

var tileset_justiz_window = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/justizausbildungszentrum/window/justizausbildungszentrum_window.json"
}));

tileset_justiz_window.style = windowStyle;

tileset_justiz_window.show = false;

//Vegetation-Baueme SolitaryVegetationObject with Implicit Representation
var tileset_veg_implicit_geom = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/veg_implicit_geom/veg_implicit_geom.json"
}));

tileset_veg_implicit_geom.style = veg_implicit_geomStyle;

tileset_veg_implicit_geom.show = false;

//Vegetation-Baueme SolitaryVegetationObject with Implicit Representation
var tileset_faechergeometrie = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/faechergeometrie/faechergeometrie.json"
}));

tileset_faechergeometrie.show = false;

//Vegetation-PlantCover
var tileset_plantcover = viewer.scene.primitives.add(new Cesium.Cesium3DTileset({
 url: "./geometry/plantcover/plantcover.json"
}));

tileset_plantcover.show = false;